//
//  myProjectSQLiteAppDelegate.m
//  myProjectSQLite
//
//  Created by Javier Cala Uribe on 1/04/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "myProjectSQLiteAppDelegate.h"
#import "myProjectSQLiteViewController.h"

@interface myProjectSQLiteAppDelegate (Private)
- (void)createEditableCopyOfDatabaseIfNeeded;
@end

@implementation myProjectSQLiteAppDelegate

@synthesize window;
@synthesize viewController;


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    
	[self createEditableCopyOfDatabaseIfNeeded];
	
    [window addSubview:viewController.view];
    [window makeKeyAndVisible];
	
	return YES;
}

- (void)createEditableCopyOfDatabaseIfNeeded {
    
	BOOL success;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSError *error;
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    NSString *writableDBPath = [documentsDirectory stringByAppendingPathComponent:@"myDB"];
    success = [fileManager fileExistsAtPath:writableDBPath];
	
	// Si ya existe el archivo, no lo crea -_-
    if (success) return;

	// Crea el archivo en el dispositivo
    NSString *defaultDBPath = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:@"myDB"];
    success = [fileManager copyItemAtPath:defaultDBPath toPath:writableDBPath error:&error];
    if (!success) {
        NSAssert1(0, @"Failed to create writable database file with message '%@'.", [error localizedDescription]);
    }
}

- (void)dealloc {
    [viewController release];
    [window release];
    [super dealloc];
}


@end
