//
//  myProjectSQLiteViewController.m
//  myProjectSQLite
//
//  Created by Javier Cala Uribe on 1/04/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "myProjectSQLiteViewController.h"

#import "sqlite3.h"

@implementation myProjectSQLiteViewController

- (void)viewDidLoad {
    [super viewDidLoad];
	
	NSString *sentencetDB = @"insert into userTable values ( NULL, 'Javier', 'Programador' )";
	[self executeSentence:sentencetDB sentenceIsSelect:NO];
	
	sentencetDB = @"select * from userTable";
	[self executeSentence:sentencetDB sentenceIsSelect:YES];
	
}

-(void)executeSentence:(NSString *)sentence sentenceIsSelect:(BOOL )isSelect{
	
	// Variables para realizar la consulta
	static sqlite3 *db;     
	sqlite3_stmt *resultado; 
	const char* siguiente;  

	// Buscar el archivo de base de datos
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    NSString *path = [documentsDirectory stringByAppendingPathComponent:@"myDB"];
		
	// Abre el archivo de base de datos
	if (sqlite3_open([path UTF8String], &db) == SQLITE_OK) {		
		
		if (isSelect){				

			// Ejecuta la consulta
			if ( sqlite3_prepare(db,[sentence UTF8String],[sentence length],&resultado,&siguiente) == SQLITE_OK ){

				// Recorre el resultado
				while (sqlite3_step(resultado)==SQLITE_ROW){		
					NSLog([NSString stringWithFormat:@"ID:%@ NAME:%@ INFO:%@",
						   [NSString stringWithUTF8String: (char *)sqlite3_column_text(resultado, 0)],
						   [NSString stringWithUTF8String: (char *)sqlite3_column_text(resultado, 1)],	
						   [NSString stringWithUTF8String: (char *)sqlite3_column_text(resultado, 2)] ]						  
						  );					
				}
			}
		}
		else {
			// Ejecuta la consulta
			if ( sqlite3_prepare_v2(db,[sentence UTF8String],[sentence length],&resultado,&siguiente) == SQLITE_OK ){
				sqlite3_step(resultado);				
				sqlite3_finalize(resultado);
			}			
		}
	} 
	// Cierra el archivo de base de datos
	sqlite3_close(db);	
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)dealloc {
    [super dealloc];
}

@end
